#include <opencv2/opencv.hpp>
#include <vector>
#include <string>
#include<iostream>
#include <sstream>
#include <stdlib.h>
#include <memory.h>
#include <fstream>
#include <direct.h>
#include <windows.h>

using namespace std;
using namespace cv;



string STR_DATASET_PATH1a = "C:\\Data Drive\\Opencv Projects\\FinalConvexHullRatioAPR21\\UNL_PGCDataset\\";  //Directory of the dataset (view 0)
string STR_DATASET_PATH1b = "\\SideView0";
string STR_DATASET_PATH2a = "C:\\Data Drive\\Opencv Projects\\FinalConvexHullRatioAPR21\\UNL_PGCDataset\\";  //Directory of the dataset (view 90)
string STR_DATASET_PATH2b = "\\SideView90";

string FOLDER_NAME_LIST = "C:\\Data Drive\\Opencv Projects\\FinalConvexHullRatioAPR21\\foldernamelist.txt";  // File of the plant ID list
string STR_IMNAME_LIST  = "C:\\Data Drive\\Opencv Projects\\FinalConvexHullRatioAPR21\\UNL_PGCDataset\\imnamelist.txt";                   // File of the image name list

string STR_RESULT_SIDEVIEW90 = "C:\\Data Drive\\Opencv Projects\\FinalConvexHullRatioAPR21\\ConvexHullRatioFiles\\Result_sideview90.txt";
string STR_RESULT_SIDEVIEW0  = "C:\\Data Drive\\Opencv Projects\\FinalConvexHullRatioAPR21\\ConvexHullRatioFiles\\Result_sideview0.txt";
string STR_RESULT_RATIO      = "C:\\Data Drive\\Opencv Projects\\FinalConvexHullRatioAPR21\\ConvexHullRatioFiles\\Result_ratio.txt";


string STR_DATASET_PATH1;
string STR_RESULT_PATH1;
string STR_RESULT_PATH2;
string STR_DATASET_PATH2;


double ConvexHullArea(Mat1b originalImage, Mat1b backgroundImage, Mat3b & contour);  // Function declaration


void StringToFileName(string FolderName){

	STR_DATASET_PATH1=STR_DATASET_PATH1a + FolderName + STR_DATASET_PATH1b;
	STR_DATASET_PATH2=STR_DATASET_PATH2a + FolderName + STR_DATASET_PATH2b;
	}


int main()
{
	double e1 = getTickCount();

	string FolderName, FileName;
	string FileIdentifier0, FileLocation0,FileIdentifier90, FileLocation90, FileIdentifier; 
	string SourceFileLocation0, DestinationFileLocation0, SourceFileLocation90, DestinationFileLocation90; 	

	
	std::ifstream FolderNameList(FOLDER_NAME_LIST.c_str());

	if(!FolderNameList.is_open())
	{
		cout<<"FOLDER_NAME_LIST File cannot be opened";
		return 0;
	}

	// For sideview90

	ofstream ResultSideview90(STR_RESULT_SIDEVIEW90.c_str(),std::ofstream::out);

	//---------------------------------------------------------------------------

	// For sideview0
	ofstream ResultSideview0(STR_RESULT_SIDEVIEW0.c_str(),std::ofstream::out);

	//----------------------------------------------------------------------------
	// For Ratio

	ofstream ResultRatio(STR_RESULT_RATIO.c_str(),std::ofstream::out);

	while(!FolderNameList.eof()){

		cout<<"Program title: To compute ratio of convex hull of plants in side view 0 degree and side view 90 degree"<<endl;
		cout<<"Developed by: SRUTI DAS CHOUDHURY"<<endl;
		cout<<"---------------------------------------------"<<endl;
		std::wcout << (wchar_t)0xA9 << " Laboratory for Image-based Innovation in Plant Phenotyping (I2P2 Lab)" << std::endl;
		
		cout<<"-------------------------------------------------------------"<<endl;
		
				
 //--------------------------------------------------------------------------------------------------------------------------------

		
		double ConvexHullArea0;
		double ConvexHullArea90;
		double ConvexHullRatio;

		int counter=1;

		Mat1b backgroundImage0,backgroundImage90;

 //------------------------------------------------------------------------------

 		getline(FolderNameList,FolderName);

		cout<<"The name of folder under processing: \t"<<FolderName<<endl;
		cout<<"-------------------------------------------------------------"<<endl;
		
		StringToFileName(FolderName);

		STR_RESULT_PATH1 = "C:\\Data Drive\\Opencv Projects\\FinalConvexHullRatioAPR21\\Result-SideView0";
		STR_RESULT_PATH2 = "C:\\Data Drive\\Opencv Projects\\FinalConvexHullRatioAPR21\\Result-SideView90";

		
		std::ifstream FileNameList(STR_IMNAME_LIST.c_str());
//---------------------------------------------------------------------------------

		while (!FileNameList.eof()){

						
		getline(FileNameList,FileName);

							
			if(FileName.compare("Day_001.png")==0){			

				backgroundImage0 = imread((STR_DATASET_PATH1+"\\"+FileName).c_str(),IMREAD_GRAYSCALE);
				backgroundImage90 = imread((STR_DATASET_PATH2+"\\"+FileName).c_str(),IMREAD_GRAYSCALE);

				}else{

			FileIdentifier = FolderName+FileName;		

			FileIdentifier0 = FolderName+"_SV0_"+FileName;
			SourceFileLocation0=STR_DATASET_PATH1+"\\"+FileName;
			DestinationFileLocation0=STR_RESULT_PATH1+"\\"+FileIdentifier0;

			
			cout<<"Now processing sideview0 image \t"<<counter<<":\t "<<FileName<<endl;

			Mat1b originalImage0 = imread(SourceFileLocation0.c_str(), IMREAD_GRAYSCALE);

			Mat3b contour0(originalImage0.rows, originalImage0.cols, Vec3b(0,0,0));

			ConvexHullArea0 = ConvexHullArea(originalImage0, backgroundImage0, contour0);

			imwrite(DestinationFileLocation0.c_str(), contour0);

			// ==============================================================================================

			FileIdentifier90 = FolderName+"_SV90_"+FileName;
			SourceFileLocation90=STR_DATASET_PATH2+"\\"+FileName;
			DestinationFileLocation90=STR_RESULT_PATH2+"\\"+FileIdentifier90;

			cout<<"Now processing sideview90 image "<<counter<<":\t "<<FileName<<endl;
				
			Mat1b originalImage90 = imread(SourceFileLocation90.c_str(), IMREAD_GRAYSCALE);

			Mat3b contour90(originalImage90.rows, originalImage90.cols, Vec3b(0,0,0)); 			

			ConvexHullArea90 = ConvexHullArea(originalImage90, backgroundImage90, contour90);

			imwrite(DestinationFileLocation90.c_str(), contour90);

			//=================================================================================================

			// Finding the ratio and saving it into respective files

			ConvexHullRatio=ConvexHullArea0/ConvexHullArea90;

			ResultSideview0<<FileIdentifier0<<"\t"<<ConvexHullArea0<<endl;
			ResultSideview90<<FileIdentifier90<<"\t"<<ConvexHullArea90<<endl;
			ResultRatio<<FileIdentifier<<"\t"<<ConvexHullRatio<<endl;

			//cout<<FileIdentifier<<"\t"<<ConvexHullRatio<<endl;

			counter++;
			}
		}
		FileNameList.close();
	}

	FolderNameList.close();
	ResultSideview0.close();
	ResultSideview90.close();
	ResultRatio.close();

	cout<<"All done! \n\nPress any key to continue ..."<<endl;

	double e2 = getTickCount();

	double time = (e2 - e1)/getTickFrequency();
	cout << "The total time of execution" <<time << endl;

	while (!getchar())
	{
		return 0;
	}	
		
		
}   // End of main




double ConvexHullArea(Mat1b originalImage, Mat1b backgroundImage, Mat3b & contour)
	 
{
	double chull_area=0.0;

	// Create binary mask
    Mat1b grayImage;
    absdiff(originalImage, backgroundImage, grayImage);
    Mat1b binary;
    threshold(grayImage, binary, 80, 255, THRESH_BINARY);

    
    // Take a ROI
	Rect roi(300,0,binary.size().width-600,binary.size().height);
    Mat1b imageROI = binary(roi);
    


    // Apply morphological dilate, 2 times
	Mat1b binaryMorph;
    Mat1b kernel = getStructuringElement(MORPH_ELLIPSE, Size(3, 3));
    dilate(imageROI, binaryMorph, kernel, Point(-1, -1), 2);

   
    // Find blob contours
    vector<vector<Point>> contours;
    double largest_area = 0.0;
    int largest_contour_index = 0;
    findContours(binaryMorph.clone(), contours, RETR_EXTERNAL, CHAIN_APPROX_SIMPLE,roi.tl());

    if (!contours.empty())
    {
        // Find largest contour
        for (size_t i = 0; i < contours.size(); i++)
        {
            double a = contourArea(contours[i], false);
            if (a > largest_area)
            {
                largest_area = a;
                largest_contour_index = i;
            }
        }

        // Draw largest contors
		        
		drawContours(contour, contours, largest_contour_index, Scalar(255,255,255), CV_FILLED);

        // Find convex hull of largest contour
        vector<Point>hull;
        convexHull(contours[largest_contour_index], hull, CV_CLOCKWISE, true);

        // Draw the convex hull

        vector<vector<Point>> tmp;
        tmp.push_back(hull);
        drawContours(contour, tmp, 0, Scalar(0,0,255), 10);

		//Display convex hull and the biggest contour

		#if DISPLAY_ON
				namedWindow( "Contour", WINDOW_NORMAL);
				imshow("Contour", contour);
		#endif

		//Compute area of convex_hull

		chull_area=contourArea(hull);     
		
				
    }  // End if

	return chull_area;

}  // End of function ConvexHullArea